' Copyright 2008 - 2009 Jozef Vince <jozef.vince@freemap.sk>
'
' This file is part of OSMtracker.
'
' OSMtracker is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License version 3 as
' published by the Free Software Foundation.
'
' OSMtracker is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with OSMtracker. If not, see <http://www.gnu.org/licenses/>.

Option Explicit On
Option Strict On


Public Class ButtonPreview


    Private Shared DisplaySizes(,,) As Integer = {{{176, 220}, {176, 220}, {176, 220}, {176, 220}}, _
                                                  {{240, 320}, {240, 320}, {320, 240}, {320, 240}}, _
                                                  {{480, 640}, {480, 640}, {640, 480}, {640, 480}}, _
                                                  {{240, 240}, {240, 240}, {240, 240}, {240, 240}}, _
                                                  {{1024, 600}, {1024, 600}, {1024, 600}, {1024, 600}} _
                                                 }
    
    Private Enum Resolutions As Integer
        SMARTPHONE
        QVGA
        VGA
        SQVGA
        NETBOOK
    End Enum
    Private Enum Orientations As Integer
        Portrait = 0
        PortraitFullscreen = 1
        Landscape = 2
        LandscapeFullscreen = 3
    End Enum

    Private displayResolution As Resolutions = Resolutions.QVGA
    Private displayOrientation As Orientations = Orientations.Landscape

    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged
        Dim hasFix As Boolean
        hasFix = CheckBox1.Checked
        ButtonPanel1.SetupPage(hasFix)
    End Sub

    Private Sub DisplayResolutionChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DisplayLandscape.CheckedChanged, DisplayLandscape.CheckedChanged, DisplayPortrait.CheckedChanged, DisplayNETBOOK.CheckedChanged, DisplaySQVGA.CheckedChanged, DisplayVGA.CheckedChanged, DisplayQVGA.CheckedChanged, DisplaySmartPhone.CheckedChanged
        If DisplayLandscape.Checked = True Then
            displayOrientation = Orientations.Landscape
        Else
            displayOrientation = Orientations.Portrait
        End If
        If DisplaySmartPhone.Checked = True Then
            displayResolution = Resolutions.SMARTPHONE
        End If
        If DisplayQVGA.Checked = True Then
            displayResolution = Resolutions.QVGA
        End If
        If DisplayVGA.Checked = True Then
            displayResolution = Resolutions.VGA
        End If
        If DisplaySQVGA.Checked = True Then
            displayResolution = Resolutions.SQVGA
        End If
        If DisplayNETBOOK.Checked = True Then
            displayResolution = Resolutions.NETBOOK
        End If
        ReArangeDevice()
    End Sub

    Private Sub ReArangeDevice()
        ButtonPanel1.Width = DisplaySizes(displayResolution, displayOrientation, 0)
        ButtonPanel1.Height = DisplaySizes(displayResolution, displayOrientation, 1)
    End Sub
    Private Sub ButtonPanel1_ButtonHitEx(ByRef button As Button) Handles ButtonPanel1.ButtonHitEx
        Dim buttonDialog As New EditButton(button)
        buttonDialog.ShowDialog(ButtonEditorMain)
        ButtonPanel1.SetupPage(CheckBox1.Checked)
        ButtonEditorMain.UpdateHotKeysAndHwButtons()
    End Sub

    Private Sub ButtonPreview_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        ' prevent manual closing (i.e. ALT+F4)
        e.Cancel = True
    End Sub

End Class