' Copyright 2009 Sven Strickroth <email@cs-ware.de>
'
' This file is part of OSMtracker.
'
' OSMtracker is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License version 3 as
' published by the Free Software Foundation.
'
' OSMtracker is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with OSMtracker. If not, see <http://www.gnu.org/licenses/>.

Option Explicit On
Option Strict On

Imports System.Xml
Imports System.IO.File
Public Class GPXToolMain
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim gpxDoc As New XmlDocument
        With OpenFileDialog1
            .Filter = "osmtracker trackpoint gpx-files (*-tp.gpx)|*-tp.gpx"
            .FilterIndex = 2
            .Multiselect = False
        End With

        If OpenFileDialog1.ShowDialog(Me) = Windows.Forms.DialogResult.OK Then
            Try
                gpxDoc.Load(OpenFileDialog1.FileName)
                Dim nsmgr As New Xml.XmlNamespaceManager(gpxDoc.NameTable)
                nsmgr.AddNamespace("gpx", "http://www.topografix.com/GPX/1/1")
                nsmgr.AddNamespace("xsi", "http://www.w3.org/2001/XMLSchema-instance")
                nsmgr.AddNamespace("xsi:schemaLocation", "http://www.topografix.com/GPX/1/0 http://www.topografix.com/GPX/1/0/gpx.xsd")
            Catch ex As Exception
                MsgBox("Could not load file.", MsgBoxStyle.Exclamation)
                Exit Sub
            End Try
        Else
            Exit Sub
        End If

        With OpenFileDialog1
            .Filter = "osmtracker waypoint gpx-files (*-wp.gpx)|*-wp.gpx"
            .FilterIndex = 2
            .Multiselect = False
        End With

        If OpenFileDialog1.ShowDialog(Me) = Windows.Forms.DialogResult.OK Then
            Try
                Dim wpDoc As New XmlDocument
                wpDoc.Load(OpenFileDialog1.FileName)
                Dim nsmgr As New Xml.XmlNamespaceManager(gpxDoc.NameTable)
                nsmgr.AddNamespace("gpx", "http://www.topografix.com/GPX/1/1")
                nsmgr.AddNamespace("xsi", "http://www.w3.org/2001/XMLSchema-instance")
                nsmgr.AddNamespace("xsi:schemaLocation", "http://www.topografix.com/GPX/1/0 http://www.topografix.com/GPX/1/0/gpx.xsd")
                Dim nodes As Xml.XmlNodeList = wpDoc.SelectNodes("//gpx:wpt", nsmgr)
                System.Windows.Forms.Cursor.Current = Cursors.Default
                MsgBox("start importing nodes: " & nodes.Count)
                System.Windows.Forms.Cursor.Current = Cursors.WaitCursor
                For Each xmlobj As Xml.XmlElement In nodes
                    gpxDoc.DocumentElement.AppendChild(gpxDoc.ImportNode(xmlobj, True))
                Next
            Catch ex As Exception
                MsgBox("Could not load file.", MsgBoxStyle.Exclamation)
                Exit Sub
            End Try
        Else
            Exit Sub
        End If

        With SaveFileDialog1
            .Filter = "gpx-files (*.gpx)|*.gpx"
            .FilterIndex = 2
        End With
        If SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            Try
                gpxDoc.Save(SaveFileDialog1.FileName)
            Catch ex As Exception
                MsgBox("Could not save file.", MsgBoxStyle.Exclamation)
            End Try
        End If
    End Sub
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        frmAbout.ShowDialog()
    End Sub
End Class
