' Copyright 2007 Rubke <interrubke@gmail.com>
' Copyright 2008 - 2009 Sven Strickroth <email@cs-ware.de>
' Copyright 2008 - 2009 Jozef Vince <jozef.vince@freemap.sk>
'
' This file is part of OSMtracker.
'
' OSMtracker is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License version 3 as
' published by the Free Software Foundation.
'
' OSMtracker is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with OSMtracker. If not, see <http://www.gnu.org/licenses/>.

Option Explicit On
Option Strict On

Imports System.IO
Imports System.Xml

Public Enum PagePresentationMode As Integer
    DefaultAutoSize = 0
    Fixed = 1
    BackgroundImage = 2
End Enum


''' <summary>
''' Type definition for strongly typed Pages Collection
''' </summary>
Public Class Pages
    Inherits System.Collections.Generic.Dictionary(Of Integer, Page)

    Public Function Load(ByRef oPages As XmlNode, ByVal storageFolder As String) As Boolean
        Dim oPage As XmlElement
        Dim pg As Page
        ' iterate throught all pages 
        For Each oPage In oPages.SelectNodes("page")

            If oPage.Attributes("extended") IsNot Nothing Then
                Select Case Integer.Parse(oPage.Attributes("extended").InnerText)
                    'just prepare for mutliple page object support
                    Case PagePresentationMode.DefaultAutoSize
                        pg = New Page
                    Case PagePresentationMode.Fixed
                        pg = New Page
                    Case PagePresentationMode.BackgroundImage
                        pg = New Page
                    Case Else
                        pg = New Page
                End Select
            Else
                pg = New Page
            End If
            If pg.Load(oPage, storageFolder) Then
                Add(pg.ID, pg)
            Else
                MsgBox("Error while loading page definition", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly)
            End If
        Next
    End Function

#If ButtonEditor Then
    ''' <summary>
    ''' Saves the buttons.
    ''' </summary>
    ''' <param name="oPages">xml element to serialize pages</param>
    Public Function Save(ByRef xmlDoc As XmlDocument, ByRef oPages As XmlElement) As Boolean
        Dim oPage As XmlElement
        Dim page As Page

        For Each page In Me.Values
            oPage = xmlDoc.CreateElement("page")
            page.Save(xmlDoc, oPage)
            oPages.AppendChild(oPage)
        Next
        ' TODO  implement save here 
    End Function
#End If
End Class

