' Copyright 2009 Sven Strickroth <email@cs-ware.de>
'
' This file is part of OSMtracker.
'
' OSMtracker is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License version 3 as
' published by the Free Software Foundation.
'
' OSMtracker is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with OSMtracker. If not, see <http://www.gnu.org/licenses/>.

Option Explicit On
Option Strict On

Public Class frmInputBox
#If PocketPC Then
    Private inputPanel As New Microsoft.WindowsCE.Forms.InputPanel
#End If
    Public Sub New(ByVal prompt As String, Optional ByVal title As String = "OSMtracker", Optional ByVal defaultResponse As String = "")
        InitializeComponent()
        Me.Text = title
        label.Text = prompt
        TextBox.Text = defaultResponse
        Me.Size = Screen.PrimaryScreen.WorkingArea.Size
#If PocketPC Then
        inputPanel.Enabled = True
#End If
    End Sub
    Private Sub menuItem_Cancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuItem_Cancel.Click
        Me.DialogResult = Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub
    Private Sub TextBox_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox.KeyPress
        If e.KeyChar = Chr(13) Then
            Me.DialogResult = Windows.Forms.DialogResult.OK
            Me.Close()
        End If
    End Sub
    Private Sub frmInputBox_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
#If PocketPC Then
        inputPanel.Enabled = False
#End If
    End Sub
    Public Function GetResult() As String
        Return TextBox.Text.Trim
    End Function
    Private Sub menuItem_OK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuItem_OK.Click
        Me.DialogResult = Windows.Forms.DialogResult.OK
        Me.Close()
    End Sub
End Class