' Copyright 2007 Rubke <interrubke@gmail.com>
' Copyright 2008 - 2009 Sven Strickroth <email@cs-ware.de>
'
' This file is part of OSMtracker.
'
' OSMtracker is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License version 3 as
' published by the Free Software Foundation.
'
' OSMtracker is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with OSMtracker. If not, see <http://www.gnu.org/licenses/>.

Option Explicit On
Option Strict On

Public Class frmSettings
    Public CommName As String
    Public Baudrate As Integer
    Public TileProviders As TileProviders
    Private Sub btnSaveNMEAFileTo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveNMEAFileTo.Click
#If Not Win32 Then
        Dim dialog As frmFileFolderSelectDialog = New frmFileFolderSelectDialog
#Else
        Dim dialog As New FolderBrowserDialog
#End If
        With dialog
            .SelectedPath = lblStorageFolder.Text
            If .ShowDialog = Windows.Forms.DialogResult.OK Then
                lblStorageFolder.Text = .SelectedPath
            End If
        End With
    End Sub
    Private Sub btnChoseTileFolder_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnChoseTileFolder.Click
#If Not Win32 Then
        Dim dialog As frmFileFolderSelectDialog = New frmFileFolderSelectDialog
#Else
        Dim dialog As New FolderBrowserDialog
#End If
        With dialog
            .SelectedPath = lblTileStorageFolder.Text
            If .ShowDialog = Windows.Forms.DialogResult.OK Then
                lblTileStorageFolder.Text = .SelectedPath
            End If
        End With
    End Sub
    Public Sub PopulatecomList(ByVal currentComPort As String, ByVal currentBaudRate As Integer)

        '        I use eVC Remote Registry Editor to look at
        'HKEY_LOCAL_MACHINE\Drivers\Active for sub keys and names.

        'Here is the partial list of AXIM Pocket PC 2002 device:

        'Serial: COM1()
        'IrDA:   COM4()
        'IrCOMM: COM3()
        'USB:    COM2()


        'Dim ports As String() = SerialPort.GetPortNames()
        'Array.Sort(ports, New CaseInsensitiveComparer)
        'For Each portname As String In ports
        '    cmbComPorts.Items.Add(portname)
        '    If portname = CurrentComPort Then cmbComPorts.SelectedIndex = cmbComPorts.Items.Count - 1
        'Next

        ' com ports
        Dim i As Long, portname As String
        cmbComPorts.Items.Clear()
        For i = 0 To 32
            portname = "COM" & i
            cmbComPorts.Items.Add(portname)
            If portname = currentComPort Then cmbComPorts.SelectedIndex = cmbComPorts.Items.Count - 1
        Next

        If IsWindowsMobile5OrHigher() Then
            For i = 1 To 9
                portname = "GPD" & i
                cmbComPorts.Items.Add(portname)
                If portname = currentComPort Then cmbComPorts.SelectedIndex = cmbComPorts.Items.Count - 1
            Next
        End If

        ' baudrate
        Dim item As String
        For Each item In cmbBaudrate.Items
            If item = CStr(currentBaudRate) Then cmbBaudrate.SelectedItem = item
        Next
    End Sub
    Private Sub btnOk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOk.Click
        CommName = cmbComPorts.Text
        Baudrate = CInt(cmbBaudrate.Text)
        Me.DialogResult = Windows.Forms.DialogResult.OK
        Me.Close()
    End Sub
    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        Me.DialogResult = Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub
    Private Sub rbMethodOldNew_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbIntermediateDriver.CheckedChanged, rbSerialDriver.CheckedChanged
        lblGPSport.Enabled = rbSerialDriver.Checked
        lblBaudrate.Enabled = rbSerialDriver.Checked
        cmbComPorts.Enabled = rbSerialDriver.Checked
        cmbBaudrate.Enabled = rbSerialDriver.Checked
        chkLogNMEA.Enabled = rbSerialDriver.Checked
        If chkLogNMEA.Enabled = False Then
            chkLogNMEA.Checked = False
        End If
    End Sub
    Public Sub UpdateTileProvidersList()
        lstTileProviders.Items.Clear()
        For i As Integer = 0 To TileProviders.Count - 1
            TileProviders.GotoProvider(i)
            lstTileProviders.Items.Add(TileProviders.GetCurrentName)
        Next
    End Sub
    Private Sub ContextMenuTileProviders_Popup(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ContextMenuTileProviders.Popup
        ContextMenuTileProviders_Delete.Enabled = lstTileProviders.SelectedIndex >= 0
        ContextMenuTileProviders_GetData.Enabled = lstTileProviders.SelectedIndex >= 0
    End Sub
    Private Sub ContextMenuTileProviders_Delete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ContextMenuTileProviders_Delete.Click
        If TileProviders.GotoProvider(lstTileProviders.SelectedIndex) = True Then
            TileProviders.DeleteCurrent()
            UpdateTileProvidersList()
        End If
    End Sub
    Private Sub btnSaveProvider_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveProvider.Click
        If TileProviders.AddTileProvider(txtTileProviderName.Text, lblTileStorageFolder.Text, cmboServerURLs.Text, CInt(minzoom.Value), CInt(maxzoom.Value), True) Then
            txtTileProviderName.Text = ""
            lblTileStorageFolder.Text = ""
            cmboServerURLs.Text = ""
            minzoom.Value = MIN_ZOOM
            maxzoom.Value = MAX_ZOOM
            UpdateTileProvidersList()
        End If
    End Sub
    Private Sub ContextMenuTileProviders_GetData_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ContextMenuTileProviders_GetData.Click
        If TileProviders.GotoProvider(lstTileProviders.SelectedIndex) Then
            txtTileProviderName.Text = TileProviders.GetCurrentName
            lblTileStorageFolder.Text = TileProviders.GetCurrentFolderName
            cmboServerURLs.Text = TileProviders.GetCurrentURL
            minzoom.Value = TileProviders.GetCurrentMinZoom
            maxzoom.Value = TileProviders.GetCurrentMaxZoom
        End If
    End Sub
    Private Sub minzoom_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles minzoom.ValueChanged, maxzoom.ValueChanged
        If minzoom.Value > maxzoom.Value Then
            minzoom.Value = maxzoom.Value
        End If
    End Sub
    Private Sub trackColorPreview_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles trackColorPreview.Click
        Dim cs As New ColorChooser
        cs.SelectedColor = trackColorPreview.BackColor
        If cs.ShowDialog = Windows.Forms.DialogResult.OK Then
            trackColorPreview.BackColor = cs.SelectedColor
        End If
    End Sub
    Private Sub waypointColorPreview_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles waypointColorPreview.Click
        Dim cs As New ColorChooser
        cs.SelectedColor = waypointColorPreview.BackColor
        If cs.ShowDialog = Windows.Forms.DialogResult.OK Then
            waypointColorPreview.BackColor = cs.SelectedColor
        End If
    End Sub
    Public Sub New()
        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        minzoom.Minimum = MIN_ZOOM
        minzoom.Maximum = MAX_ZOOM
        maxzoom.Minimum = MIN_ZOOM
        maxzoom.Maximum = MAX_ZOOM

#If Not Win32 Then
        Me.Size = Screen.PrimaryScreen.WorkingArea.Size
#End If
    End Sub
End Class
