' Copyright 2008 - 2009 Sven Strickroth <email@cs-ware.de>
'
' This file is part of OSMtracker.
'
' OSMtracker is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License version 3 as
' published by the Free Software Foundation.
'
' OSMtracker is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with OSMtracker. If not, see <http://www.gnu.org/licenses/>.

Option Explicit On
Option Strict On

Public Class SettingsMap
    Public TileProviders As TileProviders
    Public Sub UpdateTileProvidersList()
        lstTileProviders.Items.Clear()
        For i As Integer = 0 To TileProviders.Count - 1
            TileProviders.GotoProvider(i)
            lstTileProviders.Items.Add(New ListViewItem(TileProviders.GetCurrentName))
        Next
    End Sub
    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        Me.DialogResult = Windows.Forms.DialogResult.OK
        Me.Close()
    End Sub
    Private Sub trackColorPreview_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles trackColorPreview.Click
        Dim cs As New ColorChooser
        cs.SelectedColor = trackColorPreview.BackColor
        If cs.ShowDialog = Windows.Forms.DialogResult.OK Then
            trackColorPreview.BackColor = cs.SelectedColor
        End If
    End Sub
    Private Sub waypointColorPreview_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles waypointColorPreview.Click
        Dim cs As New ColorChooser
        cs.SelectedColor = waypointColorPreview.BackColor
        If cs.ShowDialog = Windows.Forms.DialogResult.OK Then
            waypointColorPreview.BackColor = cs.SelectedColor
        End If
    End Sub
    Private Sub MenuItem5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem5.Click
        chkDrawtrack.Focus()
    End Sub
    Private Sub MenuItem2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem2.Click
        With SettingsMapTileProvider
            .TileProviders = TileProviders
            .txtTileProviderName.Text = ""
            .lblTileStorageFolder.Text = ""
            .cmboServerURLs.Text = ""
            .minzoom.Text = "5"
            .maxzoom.Text = "17"
            .ShowDialog()
        End With
        UpdateTileProvidersList()
    End Sub
    Private Sub MenuItem3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem3.Click
        If lstTileProviders.SelectedIndices.Count = 1 AndAlso TileProviders.GotoProvider(lstTileProviders.SelectedIndices.Item(0)) Then
            With SettingsMapTileProvider
                .TileProviders = TileProviders
                .txtTileProviderName.Text = TileProviders.GetCurrentName
                .lblTileStorageFolder.Text = TileProviders.GetCurrentFolderName
                .cmboServerURLs.Text = TileProviders.GetCurrentURL
                .minzoom.Text = TileProviders.GetCurrentMinZoom.ToString
                .maxzoom.Text = TileProviders.GetCurrentMaxZoom.ToString
                .ShowDialog()
            End With
            UpdateTileProvidersList()
        End If
    End Sub
    Private Sub MenuItem4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem4.Click
        If lstTileProviders.SelectedIndices.Count = 1 AndAlso TileProviders.GotoProvider(lstTileProviders.SelectedIndices.Item(0)) Then
            TileProviders.DeleteCurrent()
            UpdateTileProvidersList()
        End If
    End Sub
    Private Sub lstTileProviders_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles lstTileProviders.GotFocus
        MenuItem1.Enabled = True
    End Sub
    Private Sub lstTileProviders_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles lstTileProviders.LostFocus
        MenuItem1.Enabled = False
    End Sub
End Class