' Copyright 2008 - 2009 Sven Strickroth <email@cs-ware.de>
'
' This file is part of OSMtracker.
'
' OSMtracker is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License version 3 as
' published by the Free Software Foundation.
'
' OSMtracker is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with OSMtracker. If not, see <http://www.gnu.org/licenses/>.

Option Explicit On
Option Strict On

Public Class SettingsMapTileProvider
    Public TileProviders As TileProviders
    Private Sub minzoom_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles minzoom.SelectedIndexChanged, maxzoom.SelectedIndexChanged
        If maxzoom.Text <> "" AndAlso Integer.Parse(minzoom.Text) > Integer.Parse(maxzoom.Text) Then
            minzoom.Text = maxzoom.Text
        End If
    End Sub
    Private Sub lblTileStorageFolder_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles lblTileStorageFolder.KeyDown
        If e.KeyCode = Keys.Enter Then
            e.Handled = True
            Dim dialog As frmFileFolderSelectDialog = New frmFileFolderSelectDialog
            With dialog
                .SelectedElement = lblTileStorageFolder.Text
                If .ShowDialog = Windows.Forms.DialogResult.OK Then
                    lblTileStorageFolder.Text = .SelectedElement
                End If
            End With
        End If
    End Sub
    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        If txtTileProviderName.Text <> "" AndAlso lblTileStorageFolder.Text <> "" Then
            MsgBox("Name and storage folder must be set!", MsgBoxStyle.Exclamation)
            Exit Sub
        End If
        If TileProviders.AddTileProvider(txtTileProviderName.Text, lblTileStorageFolder.Text, cmboServerURLs.Text, CInt(minzoom.Text), CInt(maxzoom.Text), True) Then
            Me.DialogResult = Windows.Forms.DialogResult.OK
            Me.Close()
        End If
    End Sub
    Public Sub New()
        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        minzoom.Items.Clear()
        maxzoom.Items.Clear()
        For i As Integer = MIN_ZOOM To MAX_ZOOM
            minzoom.Items.Add(i)
            maxzoom.Items.Add(i)
        Next
    End Sub
End Class