' Copyright 2007 Rubke <interrubke@gmail.com> (DownloadFile method)
'
' This file is part of OSMtracker.
'
' OSMtracker is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License version 3 as
' published by the Free Software Foundation.
'
' OSMtracker is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with OSMtracker. If not, see <http://www.gnu.org/licenses/>.

Option Explicit On
Option Strict On

Imports System.Net

Public Class Downloader
    Public Shared Function DownloadFile(ByVal url As String, ByVal fileName As String) As Boolean
        Dim request As WebRequest
        Dim response As WebResponse = Nothing
        Dim input As IO.Stream = Nothing
        Dim output As IO.FileStream = Nothing
        Dim count As Integer = 32 * 1024 ' 32k at a time
        Dim buffer(count - 1) As Byte
        Try
            request = WebRequest.Create(url)
            If request IsNot Nothing Then
                response = request.GetResponse()
                If response IsNot Nothing Then
                    input = response.GetResponseStream()
                    If input IsNot Nothing Then
                        output = New IO.FileStream(fileName, IO.FileMode.Create)
                        If output IsNot Nothing Then
                            Do
                                count = input.Read(buffer, 0, count)
                                If count = 0 Then Exit Do ' ready
                                output.Write(buffer, 0, count)
                            Loop
                        End If
                        DownloadFile = True
                    End If
                End If
            End If

        Catch ex As Exception
            ' MsgBox("error in DownloadFile (" & strUrl & ") reason : " & ex.ToString, MsgBoxStyle.Critical)
        End Try
        If input IsNot Nothing Then input.Close()
        If output IsNot Nothing Then output.Close()
        If response IsNot Nothing Then response.Close()
    End Function
End Class
