' Copyright 2008 Sven Strickroth <email@cs-ware.de>
'
' This file is part of OSMtracker.
'
' OSMtracker is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License version 3 as
' published by the Free Software Foundation.
'
' OSMtracker is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with OSMtracker. If not, see <http://www.gnu.org/licenses/>.

Option Explicit On
Option Strict On

Imports System.IO

Public Class WalkerAction_DeleteOld
    Implements WalkerAction
    Private compareDate As Date = Now.AddDays(-14)
    Private deletedTiles As Integer = 0

    Public Sub New()
    End Sub
    Public Sub New(ByVal compareDate As Date)
        Me.compareDate = compareDate
    End Sub
    Public Sub DoAction(ByVal fileName As String) Implements WalkerAction.DoAction
        If Date.Compare(File.GetLastWriteTime(fileName), compareDate) < 0 Then
            File.Delete(fileName)
            deletedTiles += 1
        End If
    End Sub
    Public Function GetDeletedTilesCount() As Integer
        Return deletedTiles
    End Function
End Class
