' Copyright 2008 Sven Strickroth <email@cs-ware.de>
'
' This file is part of OSMtracker.
'
' OSMtracker is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License version 3 as
' published by the Free Software Foundation.
'
' OSMtracker is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with OSMtracker. If not, see <http://www.gnu.org/licenses/>.

Option Explicit On
Option Strict On

Imports System.IO
Imports System.Net

Public Class WalkerAction_Info
    Implements WalkerAction
    Private compareDate As Date = Now.AddDays(-14)
    Private numberOfTiles As Integer = 0
    Private sizeOfTiles As Long = 0
    Private affectedTiles As Integer = 0
    Private sizeOfAffectedTiles As Long = 0
    Public Sub New(ByVal compareDate As Date)
        Me.compareDate = compareDate
    End Sub
    Public Sub DoAction(ByVal fileName As String) Implements WalkerAction.DoAction
        Dim tileName As FileInfo = New FileInfo(fileName)
        numberOfTiles += 1
        sizeOfTiles += tileName.Length
        If Date.Compare(tileName.LastWriteTime, compareDate) < 0 Then
            affectedTiles += 1
            sizeOfAffectedTiles += tileName.Length
        End If
    End Sub
    Public Function GetNumberOfTiles() As Integer
        Return numberOfTiles
    End Function
    Public Function GetSizeOfAllTiles() As Long
        Return sizeOfTiles
    End Function
    Public Function GetAffectedTilesCount() As Integer
        Return affectedTiles
    End Function
    Public Function GetSizeOfAffectedTilesCount() As Long
        Return sizeOfAffectedTiles
    End Function
End Class
